<!--

  Copyright (c) 2005-2012
  Eclipse Java Workflow Tooling (JWT) Project <www.eclipse.org/jwt>
 
  All rights reserved. This program and the accompanying materials
  are made available under the terms of the Eclipse Public License v1.0
  which accompanies this distribution, and is available at
  http://www.eclipse.org/legal/epl-v10.html
 

  Version: $Id: package.html,v 1.4 2009-11-26 12:41:46 chsaad Exp $

-->


<html>

<head>
  <title></title>
</head>

<body>

  <p>
    This is the main package of the Workflow project.
  </p>

  <hr/>

  <h2>Overview</h2>
  <p>
    The Workflow editor is an Eclipse plugin with a graphical editor to create 
    Workflow diagrams.
  </p>
  <p>
    The editor consists of two main parts: The <i>activity editor</i> is used to 
    graphically create activity models. The <i>model editor</i> is used to 
    create and configure all model elements.<br>
    The editor classes are located in the 
    <code><a href="editors/package-summary.html">editors</a></code> package.<br>
    <br>
  </p>
  
  <a id="activityEditor" />
  <h3>Activity Editor</h3>
  <p>
    The graphical editor is implemented by the {@link org.eclipse.jwt.we.editors.WEEditor Workflow Editor}
    using the Graphical Editing Framework (GEF). It consists of  the 
    {@link org.eclipse.jwt.we.editors.pages.WEEditorSheet activity editor} and an
    {@link org.eclipse.jwt.we.editors.pages.WEOverviewPage overview page}.
    <br>
    The GEF is using a <i>Model-View-Controller</i> pattern, i.e. it separates 
    the model from its view and combines them using controller.<br>
    The <i>model</i> is generated from the 
    <a href="model/package-summary.html#metamodel">Workflow metamodel</a> using 
    the Eclipse Modeling Framework (EMF). The model can be found in the 
    <a href="model/package-summary.html"><code>model</code> package</a>.<br/>
    The <i>view</i> is provided by {@link org.eclipse.draw2d.IFigure Figure} 
    classes and is located in the 
    <a href="figures/package-summary.html"><code>figures</code> package</a>.
    <br>
    The <i>controller</i> are provided by 
    {@link org.eclipse.gef.EditPart EditPart} classes and are located in the 
    <a href="parts/package-summary.html"><code>parts</code> package</a>.<br>
    <br>
  </p>

  <a id="modelEditor" />
  <h3>Model Editor</h3>
  <p>
    The model editor is generated by the Eclipse Modeling Framework (EMF). It is
    currently available through the 
    <code><a href="editors/outline/package-summary.html">outline</a></code> and 
    the 
    <code><a href="editors/properties/package-summary.html">properties</a></code> 
    view.
    <br>
    The model editor is based on the same model as the activity editor. The 
    content is provided through EMF 
    {@link org.eclipse.emf.edit.provider.ItemProviderAdapter ItemProviderAdapters}.
  </p>

  <hr/>
  
  <h2>Plugin</h2>
  <p>
    The Workflow editor is an Eclipse plugin. The plugin data and setting are
    located in the <code>plugin.xml</code> and <code>META-INF/MANIFEST.MF</code>
    files.<br>
    <br>
    They contain the following informations:
  </p>
  <ul>
    <li>Plugin ID</li>
    <li>Plugin version</li>
    <li>Plugin Name</li>
    <li>Plugin Provider</li>
    <li>Plugin activator class: {@link org.eclipse.jwt.we.Plugin}</li>
    <li>Plugin dependencies</li>
    <li>
      Editors: {@link org.eclipse.jwt.we.editors.WEEditor}, with
      <ul>
        <li>Extension: workflow</li>
        <li>
          Action bar contributer: 
          {@link org.eclipse.jwt.we.editors.WEActionBarContributor}
        </li>
      </ul>    
    </li>
    <li>Wizards: {@link org.eclipse.jwt.we.editors.wizards.CreationWizard}</li>
    <li>Build configuration for deployment</li>
  </ul>
  
  <hr/>

  <a id="messages" />
  <h2>Messages and Localization</h2>
  <p>
    All Strings and message used by the plugin are located in the 
    <code>plugin.properties</code>. This allows an easy localization for 
    different language. For example the property file 
    <code>plugin_de.properties</code> contains German translations of the 
    messages.<br/>
    The properties are access through static fields and methods from the
    {@link org.eclipse.jwt.we.PluginProperties} class.
  </p>
  
  <hr/>

  <h2>Framework Documentation</h2>
  <ul>
    <li>
      GEF documentation:
      <a href="http://www.eclipse.org/gef/reference/articles.html">
      http://www.eclipse.org/gef/reference/articles.html</a>.
    </li>
  
    <li>
      GefDescription <a href="http://eclipsewiki.editme.com/GefDescription">
      http://eclipsewiki.editme.com/GefDescription</a>.
    </li>
 
    <li>
      EMF documentation:
      <a href="http://www.eclipse.org/emf/docs.php">
      http://www.eclipse.org/emf/docs.php</a>.
    </li>
  
    <li>
      EMF Overview: 
      <a href="http://www.eclipse.org/emf/docs.php?doc=references/overview/EMF.html">
      http://www.eclipse.org/emf/docs.php?doc=references/overview/EMF.html</a>.
    </li>
  
    <li>
      EMF.Edit Overview: 
      <a href="http://www.eclipse.org/emf/docs.php?doc=references/overview/EMF.Edit.html">
      http://www.eclipse.org/emf/docs.php?doc=references/overview/EMF.Edit.html</a>.
    </li>
  
    <li>
     EMF Book: Eclipse Modeling Framework (Overview and Developer's Guide) 
     Sample, Chapter 2. Introduction, Defining the Model, Generating Code, EMF 
     Framework.
     <a href="http://www.awprofessional.com/content/images/0131425420/samplechapter/budinskych02.pdf">
     http://www.awprofessional.com/content/images/0131425420/samplechapter/budinskych02.pdf</a>.
    </li>
  
    <li>
      Create an Eclipse-based application using the Graphical Editing Framework
      <a href="http://www-128.ibm.com/developerworks/opensource/library/os-gef">
      http://www-128.ibm.com/developerworks/opensource/library/os-gef</a>.
    </li>
  
    <li>
      Using GEF with EMF 
      <a href="http://www.eclipse.org/articles/Article-GEF-EMF/gef-emf.html">
      http://www.eclipse.org/articles/Article-GEF-EMF/gef-emf.html</a>.
    </li>
  
    <li>
      IBM Redbook: Eclipse Development using the Graphical Editing Framework and 
      the Eclipse Modeling Framework
      <a href="http://www.redbooks.ibm.com/abstracts/sg246302.html">
      http://www.redbooks.ibm.com/abstracts/sg246302.html</a>.
    </li>
    
    <li>
      Java Logging Overview: 
      <a href="http://java.sun.com/j2se/1.5.0/docs/guide/logging/overview.html">
      http://java.sun.com/j2se/1.5.0/docs/guide/logging/overview.html</a>.
    </li>
  </ul>

  <hr/>

  <h2>Links</h2>
  <ul>
    <li>
      Eclipse home: <a href="http://www.eclipse.org">http://www.eclipse.org</a>
    </li>
    <li>
      GEF home: 
      <a href="http://www.eclipse.org/gef">http://www.eclipse.org/gef</a>
    </li>
    <li>
      EMF home: 
      <a href="http://www.eclipse.org/emf">http://www.eclipse.org/emf</a>
    </li>
  </ul>

  <hr/>

  <p>
    (c) 2005-2012  Eclipse Java Workflow Tooling (JWT) Project 
    &lt;<a href="http://www.eclipse.org/jwt">www.eclipse.org/jwt</a>&gt;
  </p>

</body>

</html>